// Opal 

inherit "std/unit";

#include <properties.h>
#include <language.h>

create()
{
  if (!is_clone(this_object()) )  return;

  ::create();

  SetProp(P_SHORT, "Ein Opal");
  SetProp(P_LONG,  
    "Der Opal schimmert magisch in allen Farben.");
  SetProp(P_INFO, 
    "Es gibt Geruechte, die Opale mit Magie in Zusammenhang bringen.\n");
  SetProp(P_NAME, ({"Opal", "Opale"}) );
  SetProp(P_GENDER, MALE);

  AddSingularId( ({"opal", "edelstein"}) );
  AddPluralId( ({"opale", "edelsteine"}) );
  AddId( "EDELSTEIN" );
  SetCoinsPerUnits(250,1);
  SetGramsPerUnits(5,1);

  SetProp(P_MATERIAL, MAT_OPAL );
  SetProp(P_NOBUY, 1);

}
