//  Rubin

inherit "std/unit";

#include <properties.h>
#include <language.h>

create()
{
  if (!is_clone(this_object()) )  return;

  ::create();

  SetProp(P_SHORT, "Ein Rubin");
  SetProp(P_LONG,  
    "Der Rubin ist ein wertvoller Edelstein und hat eine feuerrote Farbe.");
  SetProp(P_INFO, 
    "Rubine haben eine eigenartige Beziehung zu Feuer.\n");
  SetProp(P_NAME, ({"Rubin", "Rubine"}) );
  SetProp(P_GENDER, MALE);

  AddSingularId( ({"rubin", "edelstein"}) );
  AddPluralId( ({"rubine", "edelsteine"}) );
  AddId( "EDELSTEIN" );
  SetCoinsPerUnits(650,1);
  SetGramsPerUnits(5,1);

  SetProp(P_MATERIAL, MAT_RUBY );
  SetProp(P_NOBUY, 1);

}
