// Saphir 

inherit "std/unit";

#include <properties.h>
#include <language.h>

create()
{
  if (!is_clone(this_object()) )  return;

  ::create();

  SetProp(P_SHORT, "Ein Saphir");
  SetProp(P_LONG,  
    "Der Saphir ist ein eisblau glitzernder Edelstein.");
  SetProp(P_INFO, 
    "Der Saphir hat scheinbar eine enge Beziehung zum Eis.\n");
  SetProp(P_NAME, ({"Saphir", "Saphire"}) );
  SetProp(P_GENDER, MALE);

  AddSingularId( ({"saphir", "edelstein"}) );
  AddPluralId( ({"saphire", "edelsteine"}) );
  AddId( "EDELSTEIN" );
  SetCoinsPerUnits(600,1);
  SetGramsPerUnits(5,1);

  SetProp(P_MATERIAL, MAT_SAPPHIRE);
  SetProp(P_NOBUY, 1);

}
