/*
 * /obj/pkmaster.c
 * ---
 * Zustaendig fuer Playerkill-Handling
 * ---
 * Jan 08, 1997  Woody  Release
 * Jun 22, 1997  Woody  move jetzt M_GO|M_NOCHECK (wg. Erschoepfung)
 */

inherit "/std/thing";

#include <properties.h>
#include <daemon.h>
#include <moving.h>

void create() {
  if (is_clone(this_object())) remove();
}

int remove() {return 0;}

void TriedPK (object wer, object wen)
{
  object w;
  if (w=find_player("woody"))
    tell_object(w, sprintf("Tried PK: %O against %O\n", wer, wen));
  if (wer->QueryProp(P_GHOST)) {
    return;
  }
  tell_object (wer,
    "\nEin dumpfes Gefuehl ueberkommt Dich...\n"
    "Das Bild vor Deinen Augen verdunkelt sich und verschwimmt immer mehr...\n\n"
    "Du faellst...\n\n");
  wer->StopHuntFor(wen, 1);
  wen->StopHuntFor(wer, 1);
  wer->move ("/room/entscheidung", M_GO|M_NOCHECK, "geschleudert",
    "wird ganz woanders hin", "wird hereingeschleudert");
}
