#include <properties.h>

mixed *avail;

create()
{
	create_objects_list();
}

create_objects_list()
{
	mixed *tmp;

	int i;
	string sh;

	avail=get_dir("/obj/misc/*.c",1);
	for (i=sizeof(avail)-1;i>=0;i--)
	{
		avail[i]=avail[i][0..<3];
		if (catch(sh=call_other("/obj/misc/"+avail[i],"QueryProp",P_SHORT)))
			avail[i]=0;
		else
		{	
			avail[i]=({avail[i],sh});
			if (catch(sh=call_other("/obj/misc/"+avail[i][0],"QueryProp",P_VALUE)))
				avail[i]=0;
			else
				avail[i]=avail[i]+({sh});
		}
	}
	avail=avail-({0});
	tmp=({({}),({})});
	tmp[0]=allocate(sizeof(avail));
	tmp[1]=allocate(sizeof(avail));
	for (i=sizeof(avail)-1;i>=0;i--)
	{
		tmp[0][i]=avail[i][0];
		tmp[1][i]=avail[i][1..<1];
	}
	avail=order_alist(tmp);
}

query_avail()
{
	return avail;
}

create_object(str)
{
	mixed *what;

	if (!str)
		return;
	if (!pointerp(what=assoc(str,avail)))
		return -1;
	if (what=clone_object("obj/misc/"+what))
		return -2;
	return what;
}
