/* NPC-Standard Blueprint 
 * Samtpfote@tamedhon
 *
 * einfach ein search'n'replace "rassename" -> "name" machen
 *
 */

#include <class.h> 
#include <properties.h>
#include <combat.h>
#include <moving.h>

#ifdef LOG
#undef LOG
#endif
#define LOG(x, text) write_file("/log/statistik/npcs/"+x, text)


inherit "/std/mnpc";
inherit "/std/player/moneyhandler";


string *_query_racestring()
{
    if(QueryProp(P_GENDER) == MALE)
    {
	return ({"Brownie", "Brownies", "Brownie", "Brownie"});
    }
    else
    {
	return ({"Browniefrau", "Browniefraus", "Browniefrau", "Browniefrau"});
    }
}

void create_default_brownie(int level)
{
    int	num;

    ::create_default_npc(level);
    
    AddId("\nbrownie");
    AddId("brownie");
    
    SetProp(P_SPELLRATE, 10+level/2+random(level*2)); 
    if(QueryProp(P_SPELLRATE) >= 100)
    { SetProp(P_SPELLRATE, 80+random(16)); }

    if(level <= 35+random(6))
    { 
	SetProp(P_ATTRIBUTES, 
	    ([A_CON: level+(random(level)/6)-(random(level)/6),
	      A_DEX: level+(random(level)/6)-(random(level)/6),
	      A_INT: level+(random(level)/6)-(random(level)/6),
	      A_STR: level+(random(level)/6)-(random(level)/6)
	    ]));
    }
    else
    {
	SetProp(P_ATTRIBUTES, ([A_CON: 35, A_DEX: 35, A_INT: 35, A_STR: 35]));
    }
    
    SetProp(P_BODY, (level<30?level*2:level)+random(15));
    SetProp(P_HANDS, 
	({" mit flinken Fingern",
	  50+(level/3)*10+random(10),
	  DT_BLUDGEON
	}));
    SetProp(P_GENDER, MALE);
    SetProp(P_NAME, "Brownie");
    SetProp(P_RACE, "Brownie");
    SetProp(P_SHORT, "Ein unbeschriebener Brownie");
    SetProp(P_LONG, "Das ist ein unbeschriebener Brownie.\n");
    SetProp(P_AVERAGE_SIZE, 9);
    SetProp(P_SIZE, 7+random(4));
    SetProp(P_AVERAGE_WEIGHT, 800);
    SetProp(P_WEIGHT, 600+random(500));
    SetProp(P_ATTRIBUTES_OFFSETS, 
	([A_DEX: 3, A_CON: 1, A_INT: 5, A_STR: -3]));
    SetProp(P_MAX_HANDS, 2);
    SetProp(P_AGGRESSIVE, 0);
    SetProp(P_DEFAULT_INFO,
	({"zuckt ahnungslos mit den Schultern.\n",
	  "bohrt sich unwissend in die Nase.\n",
	  "hat davon keinen Schimmer.\n",
	  "verwuschelt Deine Haare.\n",
	  "blickt an Dir hoch und grinst frech.\n",
	  "zupft an Deinen Kleidern.\n",
	  "will nichts davon wissen.\n",
	  "reagiert nicht darauf.\n",
	}));
    SetProp(P_LOG_INFO, 1);
    SetProp(P_RESISTANCE, DT_AIR);
    SetProp(P_VULNERABILITY, DT_BLUDGEON);
    SetProp(P_TEMPERATURE_RANGE, ([T_RANGE_MIN: 10, T_RANGE_MAX: 30]));  
    SetProp(P_NOMAGIC, 0);
    SetProp(P_SPELLRATE, 0);
    SetProp(P_WIMPY, 0);
    SetProp(P_DIE_MSG, " schreit auf und stuerzt tot zu Boden.\n");

    SetProp(P_MSGIN, "laeuft herein");
    SetProp(P_MSGOUT, "laeuft#");
    SetProp(P_MMSGIN, "nimmt feste Gestalt an");
    SetProp(P_MMSGOUT, "loest sich vor Deinen Augen auf");
    
    SetProp(P_MAX_FOOD, 65);
    SetProp(P_MAX_ALCOHOL, 155);
    SetProp(P_MAX_DRINK, 150);
    
    SetProp(P_ALIGN, 0);

    AddClass(CL_BROWNIE);
    AddClass(CL_HUMANOID);
}

void create_default_npc(int level)
{ create_default_brownie(level); }


int create()
{
    if(!is_clone(this_object())) return 0;
    ::create();
}
