/* MEnsch
 * Samtpfote@tamedhon
 *
 * einfach ein search'n'replace "rassename" -> "name" machen
 *
 */

#include <class.h> 
#include <properties.h>
#include <combat.h>
#include <moving.h>

#ifdef LOG
#undef LOG
#endif
#define LOG(x, text) write_file("/log/statistik/npcs/"+x, text)

inherit "/std/mnpc";
inherit "/std/player/moneyhandler";

string *_query_racestring()
{
    if(QueryProp(P_GENDER) == MALE)
    {
	return ({"Mensch", "Menschens", "Mensch", "Mensch"});
    }
    else
    {
	return ({"Menschenfrau", "Menschenfraus", "Menschenfrau", "Menschenfrau"});
    }
}

void create_default_mensch(int level)
{
    int	num;

    ::create_default_npc(level);
    SetProp(P_SPELLRATE, 5+level/2+random(level*2)); 
    if(QueryProp(P_SPELLRATE) >= 100)
    { SetProp(P_SPELLRATE, 80+random(16)); }

    if(level <= 35+random(6))
    { 
	SetProp(P_ATTRIBUTES, 
	    ([A_CON: level+(random(level)/6)-(random(level)/6),
	      A_DEX: level+(random(level)/6)-(random(level)/6),
	      A_INT: level+(random(level)/6)-(random(level)/6),
	      A_STR: level+(random(level)/6)-(random(level)/6)
	    ]));
    }
    else
    {
	SetProp(P_ATTRIBUTES, ([A_CON: 35, A_DEX: 35, A_INT: 35, A_STR: 35]));
    }
    
    SetProp(P_BODY, (level<30?level*2:level)+random(15));
    SetProp(P_HANDS, 
	({" mit groben Faustschlaegen",
	  30+(level/3)*10+random(10),
	  DT_BLUDGEON
	}));
    AddId("\nmensch");
    AddId("mensch");
    
    SetProp(P_GENDER, MALE);
    SetProp(P_NAME, "Mensch");
    SetProp(P_RACE, "Mensch");
    SetProp(P_SHORT, "Ein unbeschriebener Mensch");
    SetProp(P_LONG, "Das ist ein unbeschriebener Mensch.\n");
    SetProp(P_AVERAGE_SIZE, 170);
    SetProp(P_SIZE, random(41)+150);
    SetProp(P_AVERAGE_WEIGHT, 70000);
    SetProp(P_WEIGHT, random(40000)+50000);
    SetProp(P_ATTRIBUTES_OFFSETS, 
	([A_DEX: 2, A_CON: 3, A_INT: 1, A_STR: 1]));
    SetProp(P_MAX_HANDS, 2);
    SetProp(P_AGGRESSIVE, 0);
    SetProp(P_DEFAULT_INFO,
	({"zuckt ahnungslos mit den Schultern.\n",
	  "bohrt sich unwissend in die Nase.\n",
	  "hat davon keinen Schimmer.\n",
	  "will davon gar nichts wissen.\n",
	  "verweist Dich auf jemand anders.\n",
          "hat fuer Dich gerade keine Zeit.\n",
	  "fragt sich, ob das essbar ist.\n",
	  "meint, ob Du das nicht selber rausfinden kannst.\n",
	  "vermutet, das es wo ganz anders ist.\n",
	  "interessiert sich nicht dafuer.\n",
	  "gruebelt darueber nach, aber hat trotzdem keine Ahnung.\n"
	}));
    SetProp(P_LOG_INFO, 1);
    SetProp(P_RESISTANCE, 0);
    SetProp(P_VULNERABILITY, 0);
    SetProp(P_TEMPERATURE_RANGE, ([T_RANGE_MIN: 10, T_RANGE_MAX: 30]));  
    SetProp(P_NOMAGIC, 0);
    SetProp(P_WIMPY, 0);
    SetProp(P_DIE_MSG, " faellt blutueberstroemt und sehr tot zu Boden.\n");

    SetProp(P_MSGIN, "geht herein");
    SetProp(P_MSGOUT, "geht weiter#");
    SetProp(P_MMSGIN, "erscheint mit einen leisen *POFF*");
    SetProp(P_MMSGOUT, "verschwindet mit Rauch und Gestank");
    
    SetProp(P_MAX_FOOD, 100);
    SetProp(P_MAX_ALCOHOL, 100);
    SetProp(P_MAX_DRINK, 100);
    
    SetProp(P_ALIGN, -500+random(500)+random(500));
    
    AddClass(CL_HUMANOID);
    AddClass(CL_HUMAN);        
}

void create_default_npc(int level)
{ create_default_mensch(level); }

int create()
{
    if(!is_clone(this_object())) return 0;
    ::create();
}
