/* SilberLand MUDlib
 *
 * /secure/simul_efun.c -- simul efun's
 *
 * $Date: 1997/03/15 23:44:27 $
 * $Revision: 3.50 $
 * $Log: simul_efun.c,v $
 * Revision 3.50  1997/03/15 23:44:27  Woody
 * prepared for revision control
 *
 * Revision 3.43 1997/01/21  Woody
 * townd in country() verwenden
 *
 * Revision 3.42 1997/01/10  Crea/Woody
 * explode() Sicherheitsabfrage auf stringp()
 *
 * Revision 3.41 1996/11/12  Woody
 * wieder mal TU-Adressen eingetragen...
 *
 * Revision 3.4  1996/10/27  Woody
 * VOICEMASTER Calls wieder zu altem channeld kompatibel gemacht
 *
 * Revision 3.3  1996/10/16  Woody
 * IP Adressen fuer Graz, Innsbruck, Linz eingetragen
 *
 * Revision 3.2  1996/05/07 15:22:57  Jof
 * Don't know what Jof did! '
 *
 * Revision 3.1  1996/05/06 12:21:19  Jof
 * *** empty log message ***
 *
 * Revision 3.0  1995/11/22 14:37:10  Jof
 * Updated to rev 3.0
 *
 * Revision 1.52  1995/09/19  16:55:37  Kirk
 * The object that causes call_out overflow will be destructed.
 *
 * Revision 1.51  1995/09/19  16:23:08  Kirk
 * *** empty log message ***
 *
 * Revision 1.50  1995/06/06  08:35:26  Jof
 * _notify_fail
 *
 * Revision 1.50  1995/06/05  14:51:55  Jof
 * Modified _notify_fail to allow resettings from same object!
 *
 * Revision 1.49  1995/06/05  14:35:34  Jof
 * _notify_fail
 *
 * Revision 1.48  1995/05/29  06:23:38  Jof
 * country ueberarbeitet
 *
 * Revision 1.47  1995/05/23  09:16:33  Kirk
 * swap() overloaded
 *
 * Revision 1.46  1995/05/19  16:18:17  Jof
 * ip-Maps expandet
 *
 * Revision 1.45  1995/05/15  10:30:12  Jof
 * made shutdown more secure
 *
 * Revision 1.44  1995/05/15  06:56:48  Jof
 * speed up break_string
 *
 * Revision 1.42  1995/04/21  19:32:15  Jof
 * Slow don cleaning
 *
 * Revision 1.41  1995/04/21  18:04:22  Rochus
 * P_CONTENT_CHANGE eingebaut
 *
 * Revision 1.40  1995/04/06  19:01:44  Jof
 * *** empty log message ***
 *
 * Revision 1.39  1995/03/30  13:45:53  Jof
 * Locations ...
 *
 * Revision 1.38  1995/03/27  15:08:23  Jof
 * *** empty log message ***
 *
 * Revision 1.37  1995/03/06  21:09:50  Jof
 * query_ip_number
 *
 * Revision 1.36  1995/03/02  11:29:39  Jof
 * *** empty log message ***
 *
 * Revision 1.35  1995/02/28  10:45:54  Jof
 * minor bugfixes
 *
 * Revision 1.35  1995/02/28  17:45:07  Jof
 * Bugfixes
 *
 * Revision 1.34  1995/02/20  10:22:58  Jof
 * No logging of clean_sim any more
 *
 * Revision 1.33  1995/01/04  17:42:00  Jof
 * Revision 1.32  1995/01/03  15:42:44  Jof
 * destruct ...
 *
 * Revision 1.31  1994/12/29  16:58:28  Jof
 * Revision 1.30  1994/12/23  12:20:22  Jof
 * Revision 1.29  1994/11/24  12:36:52  Jof
 * einchecken, 'bug' in destruct behoben ;-) (Rumata)
 *
 * Revision 1.28  1994/11/07  22:09:10  Jof
 * Revision 1.27  1994/11/04  10:38:47  Jof
 * Revision 1.26  1994/09/12  18:30:31  Jof
 * Revision 1.25  1994/09/12  08:49:52  Jof
 * ueberarbeitung
 *
 * Revision 1.24  1994/09/11  15:53:53  Jof
 * Revision 1.23  1994/09/09  09:51:22  Jof
 * @41- patches
 *
 * Revision 1.9  1994/03/12  00:28:40  Jof
 * Added Call-Out-Stopper
 *
 * Revision 1.2  1994/02/08  17:13:22  Hate
 * changed general #include "/sys/properties.h" to the special #include's
 * needed for the master object (this is due to the absolute path needed here)
 * now, the properties.h file doesn't contain any absolute path's anymore
 *             
 */                            

#pragma strong_types

// Absolute Pfade erforderlich - zum Zeitpunkt, wo der Master geladen
// wird, sind noch keine Include-Pfade da ...

#define SNOOPLOGFILE "SNOOP"

#include "/secure/config.h"
#include "/secure/wizlevels.h"
#include "/sys/snooping.h"
#include "/sys/language.h"
#include "/sys/thing/properties.h"
#include "/sys/wizlist.h"
#include "/sys/erq.h"
#include "/sys/lpctypes.h"
#include "/sys/daemon.h"
#include "/sys/properties.h"
#include "/sys/defines.h"

#define FILE_NAME 1
#define FILE_SIZE 2
#define FILE_DATE 4

#define IP_VALID_CACHE 86400 // Eintraege im IP-Name-Cache nach 24h erneuern
#define IP_RETRY 28800       // Retry after 8 hours if name not found

#define TO       efun::this_object()
#define TI       efun::this_interactive()
#define TP       efun::this_player()
#define PO       efun::previous_object(0)
#define LEVEL(x) query_wiz_level(x)
#define NAME(x)  capitalize(getuid(x))

#define DEBUG(x) if (find_player("jof")) tell_object(find_player("jof"),x)

/* function prototypes
 */
string dtime(int wann);
int file_date(string file);
varargs int log_file(string file, string txt, int size_to_break);
int query_wiz_level(mixed player);
mixed *remove_alist(mixed key, mixed *alist);
nomask int snoop(object me, object you);
nomask object query_snoop(object who);
string *get_dir_ext(string path);
string *new_explode(string str, string del);
varargs string country(mixed ip, string num);
void localcmd();
int query_wiz_grp(mixed wiz);
void set_living_name(string name);
object find_living(string name);
object find_player(string name);
varargs object deep_present(mixed what, object ob);
mapping ip_map;

nomask void destruct(object ob)
{
  string fname;
  object tmp;
  
  if( (fname=file_name(ob))=="/secure/master" ||
     fname=="/obj/shut" || fname=="/room/void" || fname=="/room/netztot")
    if( previous_object()!=ob && 
       (!this_interactive() || !IS_ARCH(this_interactive()) ))
    {
      write("You have no permission to destruct the specified object!\n");
      return;
    }
  if (query_once_interactive(ob) && IS_ARCH(ob) && previous_object()!=ob &&
      (!previous_object() || !IS_ARCH(geteuid(previous_object()))) &&
      (!this_interactive() || !IS_ARCH(this_interactive())))
    return;
  tmp=ob;
  while (tmp=environment(tmp))
    tmp->Set(P_LAST_CONTENT_CHANGE,time());
  efun::destruct(ob);
}

void ___updmaster()
{
  write("Removing old master ... ");
  efun::destruct(efun::find_object("/secure/master"));
  write("done.\nLoading again ... ");
  call_other("/secure/master","???");
  write("done.\n");
}

// * Herkunfts-Ermittlung

string query_ip_number(object ob)
{
  ob=ob||this_player();
  if (!interactive(ob)) return 0;
  return ob->_query_my_ip()||efun::query_ip_number(ob);
}

string query_ip_name(object ob)
{
  string ipnum;
  mixed ipname;

  ipnum=query_ip_number(ob);
  ipname=ip_map[ipnum,0];
  return efun::query_ip_name(ob) || ipnum;  // geht natuerlich nur mit ERQD
}
/*
  if (stringp(ipname))
  {
    if ((time()-ip_map[ipnum,1])>IP_VALID_CACHE)
    {
      ip_map[ipnum,1]=time();
      "/secure/master"->get_ip_name(ipnum);
    }
    return ipname;
  }
  if (++ipname>3) 
  {
    ip_map[ipnum,1]=time()-IP_VALID_CACHE+IP_RETRY;
    return ip_map[ipnum]=ipnum;
  }
  "/secure/master"->get_ip_name(ipnum);
  ip_map[ipnum,0]=ipname;
  return ipnum;
}
*/


// ====================================================================
//  NEUE VERSION VON country()  :-)
// ====================================================================

varargs string country(mixed ip, string num) {
// if(objectp(ip)) return call_other("/p/daemon/townd","town",ip);
  return call_other("/p/daemon/townd","town",ip);
  return call_other("/p/daemon/townd","town",num);
}

// ====================================================================
//  ALTE VERSION VON country()
// ====================================================================

/*

mapping countries =
(["de":  "Deutschland", "at":  "Oesterreich",      "fi":  "Finnland",
  "nl":  "Niederlande", "ch":  "Schweiz",          "au":  "Australien",
  "se":  "Schweden",    "uk":  "Grossbritannien",  "il":  "Israel",
  "ca":  "Kanada",      "fr":  "Frankreich",       "jp":  "Japan",
  "za":  "Suedafrika",  "es":  "Spanien",          "br":  "Brasilien",
  "no":  "Norwegen",    "mx":  "Mexico",           "hk":  "Hong Kong",
  "ir":  "Irland",      "pl":  "Polen",
]);
  
mapping hosts=
([
    "193.141.54.252": "Leinburg", "128.176.120.213": "Vatikan-Staat",
    "127.0.0.1": "Inside", "194.163.66.99":"Bonn",
    "194.97.68.253":"netServe HQ",
    "194.97.68.254":"netServe HQ",
    "128.176.216.149":"netServe HQ",
]);

mapping class_c=
([
  "193.141.54": "Nuernberg",      "192.109.102": "Nuernberg",
  "192.35.149": "Berlin",         "193.25.31":   "Dortmund",
  "134.176.188":"Friedberg",      "192.76.247":  "Sankt Augustin",
  "192.54.34":  "Sankt Augustin", "192.109.102": "Nuernberg",
  "192.129.36": "Nuernberg",      "193.174.71":  "Iserlohn",
  "193.174.70": "Iserlohn",       "193.101.120": "Hamburg",
  "192.35.150": "Berlin",         "193.63.56":   "Grossbritannien",
  "193.49.140": "Frankreich",     "193.25.31":   "Dortmund",
  "192.48.107": "Muenchen",       "193.170.72":  "Wien",
  "193.174.160":"Hannover",       "198.168":     "USA",
  "193.174.32":"Deutschland",     "192.101":     "Karlsruhe",
  "192.12.81": "Duesseldorf",     "193.174.46":  "Lueneburg",
  "192.109.234":"Frankfurt",      "192.88.24":   "Linz",
  "194.163.66":"Bonn",            "194:82.45":   "Cambridge",
  "198.94.165":"USA",
  "193.170.110":"Salzburg",       "193.170.224": "Graz",
  "194.152.163": "Wien",          "194.152.161": "Wien",
  "193.170.73": "Wien",           "193.170.74":  "Wien",
  "193.170.75": "Wien",           "193.170.76":  "Wien",
  "194.152.160": "Wien",
  "193.170.118": "St. Poelten",
  "193.170.156": "Leonding",
]);

mapping class_b=
([
  "134.95": "Koeln",     "141.43": "Cottbus",   "140.178": "Linz",
  "144.82": "London",    "129.13": "Karlsruhe", "139.11": "Hamburg",
  "130.49": "USA",       "129.187":"Muenchen",  "156.34": "Kanada",
  "141.56": "Dresden",   "141.76": "Dresden",   "139.33": "Grossbritannien",
  "141.30": "Dresden",   "128.138":"USA",       "141.22": "Hamburg",
  "128.176":"Muenster",  "141.52": "Karlsruhe", "129.26": "Birlinghoven",
  "141.12": "Darmstadt", "141.20": "Berlin",    "134.2":  "Tuebingen",
  "134.96": "Saarbruecken",                     "130.149":"Berlin",
  "139.18": "Leipzig",   "149.217": "Heidelberg",
  "137.222": "Bristol",  "136.199": "Trier",    "134.60": "Ulm",
  "129.16":  "Schweden", "129.217": "Dortmund", "129.70": "Bielefeld",
  "130.149": "Berlin",   "131.159": "Muenchen", "134.147":"Bochum",
  "134.169": "Braunschweig",                    "134.28": "Harburg",
  "134.30":  "Berlin",   "140.209": "USA",      "140.78": "Linz",
  "141.44":  "Magdeburg","129.206": "Heidelberg",
  "131.173": "Osnabrueck","131.220":"Bonn",     "134.102":"Bremen",
  "134.155": "Mannheim",  "134.176":"Giessen",  "137.208":"Wien",
  "141.2":   "Frankfurt", "141.21": "Karlsruhe","141.35": "Jena",
  "141.37":  "Konstanz",
  "141.51":  "Kassel",    "147.172":"Hildesheim",
  "158.94":  "Grossbritannien",                 "130.83": "Darmstadt",
  "131.152": "Basel",     "131.188":"Erlangen", "134.99": "Duesseldorf",
  "128.186": "USA",       "129.132":"Zuerich",  "129.173":"Kanada",
  "129.252": "USA",       "130.75": "Hannover", "131.215":"USA",
  "131.227": "Grossbritannien",                 "131.234":"Paderborn",
  "131.246": "Kaiserslautern",                  "132.187": "Wuerzburg",
  "132.195": "Wuppertal", "132.199": "Regensburg",
  "132.230": "Freiburg",  "132.231": "Passau",  "132.252": "Essen",
  "134.103": "Reutlingen","134.106": "Oldenburg","134.109":"Chemnitz",
  "134.117": "Kanada",    "134.130": "Aachen",   "134.226":".ie???",
  "134.91":  "Duisburg",  "137.193": "Muenchen", "137.205":"Grossbritannien",
  "137.226": "Aachen",    "137.248": "Marburg",  "139.6":  "Koeln",
  "140.142": "USA",       "140.181": "Darmstadt","141.13": "Bamberg",
  "141.24":  "Ilmenau",   "141.41":  "Wolfenbuettel",
  "141.45":  "Berlin",    "141.48":  "Halle",    "141.53": "Greifswald",
  "141.55":  "Mittweida", "141.57":  "Leipzig",  "141.7":  "Heilbronn",
  "141.83":  "Luebeck",   "143.246": "USA",      "143.93": "Trier",
  "144.32":  "Grossbritannien",                  "149.205":"Merseburg",
  "155.245": "Grossbritannien",                  "159.148":".lv???",
  "132.176": "Hagen",     "128.83":"Texas",      "141.31":"Stuttgart",
  "128.130": "Wien",      "129.27":"Graz",       "141.201":"Salzburg",
  "138.232": "Innsbruck", "131.130": "Wien",     "143.205":"Klagenfurt",
]);

mapping class_a=(["18":   "Massachusetts"]);

mapping city_translate=
([
  "ufz": "Leipzig", "cube": "Stuttgart", "uni-kl": "Kaiserslautern",
  "uka": "Karlsruhe", "fzi": "Karlsruhe", "esy": "Muenchen",
  "darmstadt": "Darmstadt", "tu-bs": "Braunschweig", "hmi": "Berlin",
  "fh-rlp": "Worms", "gsi": "Darmstadt", "schiele-ct": "Karlsruhe",
  "gwdg": "Goettingen", "uni-sb": "Saarbruecken", "fzk": "Karlsruhe",
  "tyrell": "USA", "ppp": "Hamburg", "carus": "Hamburg", "desy": "Hamburg",
  "tuwien": "Wien", "fh-rpl": "Trier", "mup": "Koeln", "tlk": "Muenster",
  "westfalen": "Muenster", "univie":"Wien",  "dkrz": "Hamburg",
  "funix": "BTX", "zehe":"Bonn", "sax":"Dresden",
  "msri": "USA", "aol": "Sehr schlechter Provider", 
  "msn":  "Extrem schlechter Provider",
  "univie": "Wien",
]);

string *prefixes = ({"kfa-","uni-","fh-","th-","tu-","fu-","wu-","mu-","tfh-",
                     "lrz-","unibw-", "ku-", "ruhr-uni-","fhtw-","fernuni-"});

varargs string country(mixed ip, string num) {
  string ret, *strs, twn;
  int a,i;
 
  if (objectp(ip))
  {
    num=query_ip_number(ip);
    ip=query_ip_name(ip);
  }  
  if( !stringp(ip) ) 
    return "?";
  ip=lower_case(ip);
  if (strstr(ip,"muenster.com",0)>=0)
    return "netServe HQ";
  if (!num)
    num=ip;
  if (ret=hosts[num])
    return ret;
  strs=explode(num,".");
  i=sizeof(strs);
  if (i>2)
  {
    ret=strs[0]+"."+strs[1];
    if (twn=(class_a[strs[0]]||class_c[ret+"."+strs[2]]||class_b[ret])) 
      return twn;
  }
  ret=ip[<2..<1];
  if (ret!="de" && ret!="at" && ip[<3..]!="com" && ip[<3..]!="org")
  {
    if (twn=countries[ret]) return twn;
    ret=ip[<3..<1];
    if (ret=="edu"||ret=="mil"||ret=="gov") return "USA";
    log_file("UNRESOLVED",sprintf("%s:%s\n",ip,num));
    return "????";
  }
  for (a=sizeof(strs=explode(ip,"."))-2;a>=0;a--)
  {
    if (twn=city_translate[strs[a]])
      return twn;
    for (i=sizeof(prefixes)-1;i>=0;i--)
      if (prefixes[i]==strs[a][0..strlen(prefixes[i])-1])
        return capitalize(strs[a][strlen(prefixes[i])..]);
  }
  log_file("UNRESOLVED",ip+"\n");
  return (ret=="de"?"Deutschland":(ret=="at"?"Oesterreich":"???"));
}
*/

// * Snoopen und was dazugehoert

static object find_snooped(object who)
{
  object *u;
  int i;

  for (i=sizeof(u=users())-1;i>=0;i--)
    if (who==efun::query_snoop(u[i]))
      return u[i];
  return 0;
}

private static string Lcut(string str)
{
  return str[5..11]+str[18..];
}

nomask int snoop(object me, object you) {
  int ret;
  object snooper0,snooper,snooper2,snooper3;
  

  if(me == you)
    return 0;
  if(me && PO) {
    snooper0=find_snooped(me);
    if(you) {
      if (PO != me && query_wiz_grp(me)>=query_wiz_grp(geteuid(PO))) 
        return 0;
      if (query_wiz_grp(me)<=query_wiz_grp(you) && !(you->QueryAllowSnoop(me)))
        return 0;
      if ((snooper=efun::query_snoop(you)) &&
          query_wiz_grp(snooper)>=query_wiz_grp(me))
      {
        if (snooper->QueryProp(P_SNOOPFLAGS && SF_LOCKED))
          return 0;
        tell_object(snooper,sprintf("%s snooped jetzt %s.\n",
                                    me->name(WER),you->name(WER)));
        snooper2=me;
        while ((snooper3=query_snoop(snooper2)))
        {
          tell_object(snooper,sprintf("%s wird seinerseits von %s gesnooped.\n",snooper2->name(WER),snooper3->name(WEM)));
          snooper2=snooper3;
        }
        efun::snoop(snooper,snooper2);
        if (efun::query_snoop(snooper2)!=snooper)
          tell_object(snooper,sprintf("Du kannst %s nicht snoopen.\n",
                                      snooper2->name(WEN)));
        else
        {
          tell_object(snooper,sprintf("Du snoopst jetzt %s.\n",
                                      snooper2->name(WEN)));
          if (!IS_ARCH(snooper))
          {
            log_file(SNOOPLOGFILE,sprintf("%s: %O %O %O\n",
                                          dtime(time()),snooper,snooper2,environment(snooper2)),100000);
            if (snooper0)
	      VOICEMASTER->SendToChannel("Snoop",this_object(),SAY,sprintf("%s *OFF* %s (%O)",capitalize(getuid(snooper)),capitalize(getuid(snooper0)),environment(snooper0)));
	    VOICEMASTER->SendToChannel("Snoop",this_object(),SAY,sprintf("%s -> %s (%O)",capitalize(getuid(snooper)),capitalize(getuid(snooper2)),environment(snooper2)));
	    /* with new channeld...
              VOICEMASTER->SendToChannel("Snoop",snooper,sprintf("%s *OFF* %s (%O)",capitalize(getuid(snooper)),capitalize(getuid(snooper0)),environment(snooper0)));
            VOICEMASTER->SendToChannel("Snoop",snooper,sprintf("%s -> %s (%O)",capitalize(getuid(snooper)),capitalize(getuid(snooper2)),environment(snooper2)));
            */
          }
        }
      } else
        if (snooper)
          if (!me->QueryProp(P_SNOOPFLAGS) & SF_LOCKED)
          {
            printf("%s wird bereits von %s gesnooped. Benutze das \"f\"-Flag, wenn du dennoch snoopen willst.\n",you->name(WER),snooper->name(WEM));
            return 0;
          }
      ret=efun::snoop(me, you);
      if (!IS_ARCH(me) && efun::query_snoop(you)==me)
      {
        log_file(SNOOPLOGFILE,sprintf("%s: %O %O %O\n",Lcut(dtime(time())),me,you,environment(you)),100000);
        if (snooper0)
	  VOICEMASTER->SendToChannel("Snoop",this_object(),SAY,sprintf("%s *OFF* %s (%O).",capitalize(getuid(me)),capitalize(getuid(snooper0)),environment(snooper0)));
	VOICEMASTER->SendToChannel("Snoop",this_object(),SAY,sprintf("%s -> %s (%O).",capitalize(getuid(me)),capitalize(getuid(you)),environment(you)));
	/* with new channeld...
          VOICEMASTER->SendToChannel("Snoop",me,sprintf("%s *OFF* %s (%O).",capitalize(getuid(me)),capitalize(getuid(snooper0)),environment(snooper0)));
        VOICEMASTER->SendToChannel("Snoop",me,sprintf("%s -> %s (%O).",capitalize(getuid(me)),capitalize(getuid(you)),environment(you)));
        */
      }
      if(ret && query_wiz_grp(me) <= query_wiz_grp(you))
        tell_object(you, "*** "+NAME(me)+" snoopt Dich!\n");
      return ret;
    } else {
      if((me == PO || 
          query_wiz_grp(geteuid(PO)) > query_wiz_grp(me) ||
          (query_wiz_grp(geteuid(PO)) == query_wiz_grp(me) && 
           query_snoop(PO)==me))&&snooper0)
      {
        if (!IS_ARCH(me))
        {
          log_file(SNOOPLOGFILE,sprintf("%s: %O %O %O *OFF*\n",Lcut(dtime(time())),me,snooper0,environment(snooper0)),100000);
	  VOICEMASTER->SendToChannel("Snoop",this_object(),SAY,sprintf("%s *OFF* %s (%O).",capitalize(getuid(me)),capitalize(getuid(snooper0)),environment(snooper0)));
	  /* with new channeld...
          VOICEMASTER->SendToChannel("Snoop",me,sprintf("%s *OFF* %s (%O).",capitalize(getuid(me)),capitalize(getuid(snooper0)),environment(snooper0)));
          */
        }
        return efun::snoop(me);
      }
    }
  }
  return 0;
}

nomask object query_snoop(object who) {
  object snooper;

  snooper=efun::query_snoop(who);
  if (!snooper) return 0;
  if (query_wiz_grp(snooper)>query_wiz_grp(getuid(previous_object())) &&
      IS_ARCH(snooper)) return 0;
  return snooper;
}

// * Emulation des 'alten' explode durch das neue

string *explode(string str, string del) {
  int s, t;
  string *strs;
  
  if (!stringp(str) || !stringp(del)) return ({});
  if (del == "")
    return ({str});
  strs=efun::explode(str, del);
  t=sizeof(strs)-1;
  while(s<=t && strs[s++] == "");s--;
  while(t>=0 && strs[t--] == "");t++;
  if(s<=t)
    return strs[s..t];
  return ({});
}

string *old_explode(string str, string del) {return explode(str,del);}

string *new_explode(string str, string del) {
  return efun::explode(str, del);
}

// * get_dir_ext: an directories einen /, an geladene Files einen * anhaengen

string *get_dir_ext(string path) {
  string *strs, file;
  mixed *finfo;
  int i, s, t;

  set_this_object(previous_object());
  if(s=sizeof(finfo=get_dir(path, FILE_NAME|FILE_SIZE))) {
    strs=(string*)MASTER->full_path_array(path, TP ? getuid(TP) : 0);
    if(t=sizeof(strs))
      path="/"+(implode(strs[0..t-2], "/")+"/");
    else
      path="/";
    strs=({});
    while(s--,s-->0) {
      file=finfo[i++];
      switch(finfo[i++]) {
        case -2:
        file+="/";
        break;
        case -1:
        file+=" -?-";
        break;
        default:
        if(find_object(path+file))
          file+="*";
      }
      strs+=({file});
    }
  }
  return strs;
}

// * Modifikations-Datum eines Files

int file_date(string file) {
  mixed *data;

  if(sizeof(data=get_dir(file, FILE_DATE)))
    return data[0];
  else
    return 0;
}

int file_time(string path)
{
  mixed *v;
  
  set_this_object(previous_object());
  if (sizeof(v=get_dir(path,4))) return v[0];
}

// * Bei 50k Groesse Log-File rotieren

varargs int log_file(string file, string txt, int size_to_break) {
  mixed *st;

  file="/log/"+file;
  file=implode((efun::explode(file,"/")-({".."})),"/");
//  tell_object(find_player("jof"),sprintf("LOG FILE: %O -> %O\n",previous_object(),file));
  if (!funcall(bind_lambda(#'efun::call_other,PO),"secure/master",//')
               "valid_write",file,geteuid(PO),"log_file",PO))
      return 0;
  if ( size_to_break >= 0 & ( 
      sizeof(st = get_dir(file,2) ) && st[0] >= (size_to_break|MAX_LOG_SIZE)))
      catch(rename(file, file + ".old")); /* No panic if failure */
  write_file(file,txt);
}

// Fuer this_player() definierte Kommandos anzeigen

void localcmd() {
  string *verbs;
  int i, s;

  if(!TP) return;
  s=sizeof(verbs=query_actions(TP));
  write("Local commands:\n");
  while(s--)
    write("'"+verbs[i++]+"' ");
  write("\n");
}

// * Magier-Level abfragen

int query_wiz_level(mixed player) {
  return (int)"/secure/master"->query_wiz_level(player);
}

// * Teile aus einem Array entfernen *** OBSOLETE

mixed *exclude_array(mixed *arr,int from,int to)
{
  if (to<from)
    to = from;
  return arr[0..from-1]+arr[to+1..];
}

// * Element aus Alist loeschen (by key)

mixed *remove_alist(mixed key,mixed *alist)
{
  int i,j;
  
  if (!pointerp(alist) || !sizeof(alist))
    return alist;
  if (!pointerp(alist[0]))
  {
    if ((i=assoc(key,alist))<0)
      return alist;
    return alist[0..i-1]+alist[i+1..];
  }
  i = assoc(key,alist[0]);
  if ((i=assoc(key,alist[0]))<0)
    return alist;
  alist=alist[0..];
  for (j=sizeof(alist)-1;j>=0;j--)
    alist[j]=alist[j][0..i-1]+alist[j][i+1..];
  return alist;
}

// * Element aus Alist loeschen (by pos)

mixed *exclude_alist(int i,mixed *alist)
{
  int j;
  if (!pointerp(alist) || !sizeof(alist) || i<0)
    return alist;
  if (!pointerp(alist[0]))
    return alist[0..i-1]+alist[i+1..];
  alist=alist[0..]; /* Create PHYSICAL copy of alist */
  for (j=sizeof(alist)-1;j>=0;j--)
    alist[j]=alist[j][0..i-1]+alist[j][i+1..];
  return alist; /* order_alist is NOT necessary - see /doc/LPC/alist */
}

// * creator *** OBSOLETE

string creator(object ob)
{
  return (string)"/secure/master"->creator_file(ob);
  //return (string)"/secure/master"->creator_file(ob)+":"+getuid(ob);
}

// * German version of ctime()

string dtime(int wann)
{
  string monat, uhrzeit, wotag, tag, jahr;
  
  sscanf(ctime(wann),"%s %s %d %s %d",wotag, monat, tag, uhrzeit, jahr);
  switch (monat)
  {
    case "May": monat="Mai"; break;
    case "Oct": monat="Okt"; break;
    case "Dec": monat="Dez"; break;
  }
  switch(wotag)
  {
    case "Sun": wotag="Son"; break;
    case "Tue": wotag="Die"; break;
    case "Wed": wotag="Mit"; break;
    case "Thu": wotag="Don"; break;
    case "Fri": wotag="Fre"; break;
    case "Sat": wotag="Sam"; break;
  }
  return wotag+(tag<=9 ? ",  " : ", ")+tag+". "+monat+" "+jahr+", "+uhrzeit;
}

// * Shutdown mit zusaetzlichem logging

nomask int shutdown(string reason)
{
  string name;
  string obname;
  string output;

  if (!reason)
    return 0;
  if ((!this_interactive()||!IS_ARCH(this_interactive())) && 
       getuid(previous_object())!=ROOTID &&
           file_name(previous_object())!="/obj/shut")
  {
    write("You have no permission to shut down the gamedriver!\n");
    return 0;
  }
  if ((this_interactive())&&(name=getuid(this_interactive())))
  {
    name=capitalize(name);
    filter_array(users(),#'tell_object,//'
                 capitalize(name)+" faehrt das Spiel herunter!\n");
  }
  else
    name="ANONYMOUS";
  if (previous_object()) obname=capitalize(getuid(previous_object()));
  output=name;
  if (obname && name!=obname) output=output+" ("+obname+")";
  if (previous_object()&&file_name(previous_object())=="/obj/shut"){
    output+=" faehrt das Spiel via Armageddon herunter.\n";
    output=dtime(time())+": "+output;
    log_file("GAME_LOG",output+"\n",-1);
    efun::shutdown();
    return 1;
  }
  output=ctime(time())+": "+output+" faehrt das Spiel herunter.\n";
  output+="    Grund: "+reason;
  log_file("GAME_LOG",output+"\n",-1);
  efun::shutdown();
  return 1;
}

// * Interactive-Struct uebertragen - zus. checks

nomask int exec(object to, object from)
{
 // return efun::exec(to, from);
  if (!to || !from || !objectp(to) || !objectp(from)) return 0;
  if (explode(file_name(from),"#")[0]=="/secure/login" ||
      file_name(previous_object())=="/secure/master")
    return efun::exec(to,from);
  if (this_interactive() != from || previous_object() != from ||
      getuid(from) != getuid(to) || geteuid(from) != geteuid(to)) return 0;
  return efun::exec(to, from);
}

// * lowerchar

int lowerchar(int char)
{
  if (char<'A' || char>'Z') return char;
  return char+32;
}

// * upperstring

string upperstring(string s)
{
  int i;
  if (!stringp(s)) return 0;
  for (i=strlen(s)-1;i>=0;i--) s[i]=((s[i]<'a'||s[i]>'z')?s[i]:s[i]-32);
  return s;
}

// * lowerstring

string lowerstring(string s)
{
  int i;
  if (!stringp(s)) return 0;
  for (i=strlen(s)-1;i>=0;i--) s[i]=((s[i]<'A'||s[i]>'Z')?s[i]:s[i]+32);
  return s;
}

// * Aufteilung des Array - see man page

mixed *unique_array(mixed *arr,string func,mixed skipnum) {
  mixed *al, last;
  int i, j, k, *ordinals;

  if (sizeof(arr) < 32) return efun::unique_array(arr, func, skipnum);
  for (ordinals = allocate(i = sizeof(arr)); i--; )
    ordinals[i] = i;
  al = order_alist(map_objects(arr, func), ordinals, (ordinals=0,arr));
  arr = al[2];
  ordinals = al[1];
  al = al[0];
  if (k = i = sizeof(al)) {
    for (last = al[j = --i]; i--; ) {
      if (al[i] != last) {
        if (last != skipnum) {
          arr[--k] = arr[i+1..j];
          ordinals[k] = ordinals[j];
        }
        last = al[j = i];
      }
    }
    if (last != skipnum) {
      arr[--k] = arr[0..j];
      ordinals[k] = ordinals[j];
    }
  }
  return order_alist(ordinals[k..], arr[k..])[1];
}

// * clone oder BP ?

status is_clone(mixed ob) {
  return objectp(ob) && member(file_name(ob), '#') >= 0;
}

// * GD version

string version()
{
  return __VERSION__;
}

// * break_string

// stretch() -- stretch a line to fill a given width
private string stretch(string s, int w)
{
  int l, i, st;
  string *t;

  if ((l=strlen(s)) == w)
    return s;

  l = w-l;
  t = regexplode(s, " ");
  if (!strlen(t[0]))
    t = ({ " "+t[2] })+t[3..];

  if ((st = sizeof(t)) < 3)
    return s;

  while (l) {
    for (i=st-3; (i>=0) && l; i-=2) {
      t[i] += " ";
      l--;
    }
  }
  return implode(t, "");
}

// repeat() -- repeat a given string c times
private string repeat(string s, int c)
{
  string ret; ret = "";
  if(c < 0) c *= -1;
  while(c--) ret += s;
  return ret;
}

#ifndef BS_SINGLE_SPACE
#define BS_SINGLE_SPACE 1
#endif

// single()  -- single out a string of spaces to one single space
private string single(string s, int flags)
{ 
  switch(s[0])
  {
  case ' ': if(flags & BS_SINGLE_SPACE) return " "; return s;
  case '\n': return "\n";
  default: return s;
  }
}

// add() -- add a prefix and a postfix to a given string
private string add(string s, string pre, string post)
{ if(strlen(s)) return pre + s + post; return s; }

#define BLOCKSATZ 1

// bs() -- my implementation of break_string()
#ifndef BLOCKSATZ
public varargs string break_string(string s, int w, mixed indent, int flags)
{
  mixed tmp;
  if(!s || s == "") return "";
  if(!(flags & BS_LEAVE_MY_LFS)) s = implode(explode(s, "\n"), " ");
  s = implode(tmp = map_array(regexplode(s, "[\n ][ ]*"), 
                              #'single/*'*/, flags), "");
  if(!stringp(indent) && intp(indent)) indent = repeat(" ", indent);
  s = sprintf("%-"+(w-strlen(indent))+"=s", s);
  if(!indent || indent == "") return s + "\n";
  return implode(map_array(efun::explode(s, "\n"),
                           #'add/*'*/, indent, ""), "\n") + "\n";
}
#else
public varargs string break_string(string s, int w, mixed indent, int flags)
{
  mixed tmp;
  int l;

  if(!s || s == "") return "";
  if ((flags & BS_BLOCK) && (flags & BS_LEAVE_MY_LFS)) {
    tmp = explode(s, "\n");
    return implode(map_array(tmp, #'break_string/*'*/, w, indent, flags&~BS_LEAVE_MY_LFS), "");
  }
  if(!(flags & BS_LEAVE_MY_LFS)) s = implode(explode(s, "\n"), " ");
  s = implode(tmp = map_array(regexplode(s, "[\n ][ ]*"),
			      #'single/*'*/, flags), "");
  if ((flags & BS_BLOCK) && !(flags & BS_NO_PARINDENT))
    s = " "+s;
  if(!stringp(indent) && intp(indent)) indent = repeat(" ", indent);
  s = sprintf("%-"+(l=w-strlen(indent))+"=s", s);

  if (flags & BS_BLOCK)
    s = implode(map_array((tmp=efun::explode(s, "\n"))[0..<2], #'stretch/*'*/, l)+({tmp[<1]}), "\n");

  if(!indent || indent == "") return s + "\n";
  return implode(map_array(efun::explode(s, "\n"),
			   #'add/*'*/, indent, ""), "\n") + "\n";
}
#endif
/*
static int width,gCol,lfsig;
static string indstr;

static string brk(string word)  {
  if (strstr(word, "\n") > -1)  {
    lfsig=1;
    gCol=strlen(indstr)+1;
    if ((gCol+strlen(word)-1)>width)
      return "\n"+indstr+word+indstr;
    else
      return " "+word+indstr;
  }
  else  {
    int zz;
    zz=lfsig;
    lfsig=0;
    if ((gCol+strlen(word)+1)>width)  {
      gCol=strlen(indstr)+strlen(word);
      return "\n"+indstr+word;
    }
    else  {
      gCol+=strlen(word)+1;
      return (zz ? "" : " ")+word;
    }
  }
}

static string bnlfs(string word)  {
  int zz;

  zz=lfsig;
  lfsig=0;
  if ((gCol+strlen(word)+1)>width) {
    gCol=strlen(indstr)+strlen(word);
    return "\n"+indstr+word;
  }
  else  {
    gCol+=strlen(word)+1;
    return (zz ? "" : " ")+word;
  }
}

#define __LFS "                                                          "
#define LFS (__LFS __LFS)

public varargs string
break_string(string str, int _width, mixed indent, int flags)
{
  string *tmp,*a,*b;
  int i,j,k,l;

  if (!str || str=="")
    return str;             // Ein Scherzbold war am Werk...

  if (flags&BS_LEAVE_MY_LFS)
  {
    flags&=~BS_LEAVE_MY_LFS;
    a=efun::explode(str,"\n");
    for (i=sizeof(a)-1;i>=0;i--)
    {
      a[i]=break_string(a[i],_width,indent,flags);
      if (a[i]=="") a[i]="\n";
    }
    return implode(a,"");
  }
  width=_width;
  lfsig=2;
  if (indent)  {
    if (intp(indent))       // Soviel spaces sollten reichen!
      indstr=LFS[1..indent];
    else if (stringp(indent))  {
      indstr=indent;
      indent=strlen(indstr);
    }
    else  {          // Sicher ist sicher. Koennte ja auch ein obj sein
      log_file(explode(file_name(previous_object()), "/")[1]+".rep", 
               "BUG GAME: Illegal argument indent to break_string in file "+
               file_name(previous_object())+"\n");
      return "";
    }
  }
  else
    indstr="";
  gCol=indent;
  for (i=strlen(str)-1;i>=0;i--)
    if (str[i]=='\n') str[i]=' ';
  while (str!="" && str[<1]==32)
    str=str[0..<2];
  if ((flags & BS_BLOCK) && !(flags & BS_NO_PARINDENT))
    if (strlen(str))
      if (str[0]==' ')
        str[0]='x';
      else
        str="x"+str;
  if (sizeof(tmp=map_array(explode(str, " "),#'bnlfs))) //#')))
    tmp[0]=indstr+tmp[0];
        str=implode(efun::explode(implode(tmp,""),"\n")-({indstr}),"\n")+"\n";
  if (!(flags&BS_BLOCK))
    return str;
  if (!(flags & BS_NO_PARINDENT))
    str=str[1..];
  a=explode(str,"\n"); // Einzelne Zeilen
  if (strlen(a[0])<_width && a[0][0..0]!=" " &&
      !(flags&BS_NO_PARINDENT))
    a[0]=" "+a[0];
  for (i=sizeof(a)-2;i>=0;i--) // der Reihe nach bearbeiten
  {
    l=strlen(a[i]);           // Laenge der akt. Zeile
    if (l<_width && member(a[i][1..],' ')>=0) // Kein Leerzeichen? Nichts tun
    {
      b=efun::explode(a[i]," "); // Fragmente erzeugen
      for (j=sizeof(b)-1;j>0;j--)
        if (l<_width && ((b[j]!="" && member(",.-()[]{}!?",b[j][0])>=0) || 
                    (j>0&&b[j-1]!="" &&
                     member(",.-()[]{}!?",b[j-1][<1])>=0)))
          b[j]=" "+b[j],l++;
      if (l<_width)
        for (j=sizeof(b)-1;j>0;j--)
          if (l<_width &&
              ((b[j]=="" || b[j][0]!=' ') && (b[j-1]=="" || b[j-1][<1]!=' ')))
            b[j]=" "+b[j], l++;
      while (l<_width)
        for (j=sizeof(b)-1;j>0;j--)
        {
          if (l<_width)
            b[j]=" "+b[j], l++;
          if (l<_width) 
            b[sizeof(b)-j]=" "+b[sizeof(b)-j], l++;
        } 
      a[i]=implode(b," ");
    }
  }
  return implode(a,"\n")+"\n";
}
*/
// * Elemente aus mapping loeschen - mapping vorher kopieren

mapping m_delete(mapping m, mixed key) {
  return efun::m_delete(copy_mapping(m), key);
}

// * times

static int last_reboot;

int last_reboot_time()
{
  return last_reboot;
}

int first_boot_time()
{
  return 701517600;
}

int exist_days()
{
  return (((time()-first_boot_time())/8640)+5)/10;
}

// * uptime :)

string uptime()
{
  int t;
  int tmp;
  string s;

  t=time()-last_reboot_time();
  s="";
  if (t>=86400)
    s+=sprintf("%d Tag%s, ",tmp=t/86400,(tmp==1?"":"e"));
  if (t>=3600)
    s+=sprintf("%d Stunde%s, ",tmp=(t=t%86400)/3600,(tmp==1?"":"n"));
  if (t>60)
    s+=sprintf("%d Minute%s und ",tmp=(t=t%3600)/60,(tmp==1?"":"n"));
  return s+sprintf("%d Sekunde%s",t=t%60,(t==1?"":"n"));
}

// * Was tun bei 'dangling' lfun-closures ?

void dangling_lfun_closure() {
  raise_error("dangling lfun closure\n");
}

// * Sperren ausser fuer master/simul_efun

nomask void efun308(object o1, object o2) {raise_error("Available only for root\n");}
nomask void set_this_player() {raise_error("Available only for root\n");}
// * Rekursiv envs liefern

public object *all_environment(object ob)
{
  object *r;
  
  if (!ob || !environment(ob)) return 0;
  if (!environment(environment(ob)))
    return ({ environment(ob) });
  r = ({ ob = environment(ob) });
  while (environment(ob))
    r = r + ({ ob = environment(ob) });
  return r;
}

// * actions auf den neusten Stand bringen

public void update_actions()
{
  int objs;

  if (environment(previous_object()))
    previous_object()->move(environment(previous_object()),1);
  filter_array(all_inventory(previous_object()),"move_inv",previous_object());
}

static void move_inv(object ob) 
{ 
  if (living(ob)) ob->move(previous_object(),1); 
}

// * Jetzt auch closures

nomask string process_string(mixed str)
{
  set_this_object(previous_object());
  if (closurep(str))
    return funcall(str);
  if (!stringp(str))
    return str;
  return efun::process_string(str);
}

// * Properties ggfs. mitspeichern

void save_object(string name)
{
  mapping properties;
  mapping save;
  mixed index;
  int i;

  save = allocate_mapping(0, 2);
  properties = previous_object()->QueryProperties();

  if(mappingp(properties))
  {
    // delete all entries in mapping properties without SAVE flag!
    index = m_indices(properties);
    for(i = sizeof(index)-1; i>=0;i--)
    {
      if(properties[index[i], F_MODE] & SAVE)
      {
        save[index[i]] = properties[index[i]];
        save[index[i], F_MODE] = 
          properties[index[i], F_MODE] & 
            (~(SETMNOTFOUND|QUERYMNOTFOUND|QUERYCACHED|SETCACHED));
      }
    }
  }
  else save = ([]);
  
  // save object!
  previous_object()->_set_save_data(save);
  funcall(bind_lambda(#'efun::save_object, previous_object()), name);
  previous_object()->_set_save_data(0);
}

// * Auch Properties laden

int restore_object(string name)
{
  int result;
  mixed index;
  mapping save;
  mapping properties;
  int i;
  closure cl;
  
  // get actual property settings (by create())
  properties = previous_object()->QueryProperties();

//  DEBUG(sprintf("RESTORE %O\n",name));
  // restore object
  result=funcall(bind_lambda(#'efun::restore_object, previous_object()), name);
  //'))
  save = previous_object()->_get_save_data();
  if(mappingp(save))
  {
    index = m_indices(save);
    for(i = sizeof(index)-1; i>=0; i--)
    {
      properties[index[i]] = save[index[i]];
      properties[index[i], F_MODE] = save[index[i], F_MODE]
        &~(SETCACHED|QUERYCACHED);
    }
  }
  else properties = ([]);
  
  // restore properties
  cl=unbound_lambda(({'arg}),
                          ({#'call_other,({#'this_object}), //'
                            "SetProperties",'arg})); //'})}))
  (void)funcall(
                bind_lambda(
                            unbound_lambda(({'arg}), //'})
                                           ({#'call_other,({#'this_object}),
                                           "SetProperties",'arg})),//')
                            previous_object()),properties);
  previous_object()->_set_save_data(0);
  return result;
}

// * HB eines Objektes ein/ausschalten

int set_object_heart_beat(object ob, int flag)
{
  if (objectp(ob))
    return funcall(bind_lambda(#'efun::set_heart_beat,ob),flag);
}

// * Magierlevelgruppen ermitteln

int query_wiz_grp(mixed wiz)
{
  int lev;

  lev=query_wiz_level(wiz);
  if (lev<SEER_LVL) return 0;
  if (lev>=GOD_LVL) return lev;
  if (lev>=ARCH_LVL) return ARCH_GRP;
  if (lev>=ELDER_LVL) return ELDER_GRP;
  if (lev>=LORD_LVL) return LORD_GRP;
  if (lev>=SPECIAL_LVL) return SPECIAL_GRP;
  if (lev>=DOMAINMEMBER_LVL) return DOMAINMEMBER_GRP;
  if (lev>=WIZARD_LVL) return WIZARD_GRP;
  if (lev>=LEARNER_LVL) return LEARNER_GRP;
  return SEER_LVL;
}

// * wizlist ausgeben

void wizlist(string name) {
  int i, pos, total_cmd;
  int *cmds;
  mixed *a;
  mixed *b;

  if (!name) {
    if (this_player())
                        name = getuid(this_player());
    if (!name)
      return;
  }
  a = transpose_array(wizlist_info());
  cmds = a[WL_COMMANDS];
  a[WL_COMMANDS] = a[0];
  a[0] = cmds;
  a = order_alist(a);
  cmds = a[0];
  a[0] = a[WL_COMMANDS];
  a[WL_COMMANDS] = cmds;
  if ((pos = member(a[WL_NAME], name)) < 0 && name != "ALL")
    return;
  b = allocate(sizeof(cmds));
  for (i = sizeof(cmds); i;) {
    b[<i] = i;
    total_cmd += cmds[--i];
  }
  a = transpose_array(a + ({b}) );
  if (name != "ALL") {
    if (pos + 18 < sizeof(cmds)) {
      a = a[pos-2..pos+2]+a[<15..];
    } else if (pos < sizeof(cmds) - 13) {
      a = a[pos-2..];
    } else {
      a = a[<15..];
    }
  }
  write("\nWizard top score list\n\n");
  if (total_cmd == 0)
    total_cmd = 1;
  for (i = sizeof(a); i; ) {
    b = a[<i--];
    printf("%-15s %5d %2d%% (%d)\t[%4dk,%5d] %6d %d\n",
           b[WL_NAME], b[WL_COMMANDS], b[WL_COMMANDS] * 100 / total_cmd, b[<1],
           b[WL_EVAL_COST] / 1000,
           b[WL_HEART_BEATS], b[WL_EXTRA], b[WL_ARRAY_TOTAL]
           );
  }
  printf("\nTotal         %7d     (%d)\n\n", total_cmd, sizeof(cmds));
}

static int _cost_sort(mixed *a, mixed *b)
{
        return a[WL_EVAL_COST]<b[WL_EVAL_COST];
}

#ifdef CALL_OUT_INFO_DAMAGED
nomask mixed *call_out_info(){return ({});}
#else
#ifndef TESTMUD
static int CallOutStopped = 0;
static int CallOutCount;
static int CountMessages = 0;
static string LastMessage;

void StopCallOut(int arg)
{
  if (arg && extern_call() && file_name(previous_object())!="/secure/master")
    return 0;
  if (arg && !CallOutStopped)
    write_file("/log/call_out_stop",sprintf("__CALLED %s (%d)\n__(CUT HERE)__\n",
                                            ctime(time()),arg));
  CallOutStopped=arg;
}

#ifdef STOP_CALL_OUTS_HARD
varargs void call_out(mixed what, int delay, mixed arg1, mixed arg2, 
                      mixed arg3, mixed arg4, mixed arg5, mixed arg6,
                      mixed arg7, mixed arg8, mixed arg9, mixed arg10,
                      mixed arg11, mixed arg12, mixed arg13, mixed arg14,
                      mixed arg15)
{
  object tmp;
  int num;
  string message;

  if (CallOutStopped)
  {
    message=sprintf("%O %O\n",previous_object(),what);
    if(LastMessage==message)
      CountMessages++;
    else
    {
      if (CountMessages)
      {
        write_file("/log/call_out_stop",
                   sprintf("Last message repeated %d times.\n",CountMessages));
        CountMessages=0;
      }
      write_file("/log/call_out_stop",message);
      LastMessage=message;
    }
    return;
  }
  if (!(++CallOutCount%50))
  {
    if((num=sizeof(call_out_info()))>CALL_OUT_HARD)
    {
      write("!!! EMERGENCY !!! MAX NUMBER OF CALL_OUTS EXCEEDED !!! CALL_OUT STOPPED !!!\n");
      filter_array(users(),#'tell_object,"!!! EMERGENCY !!! MAX NUMBER OF CALL_OUTS EXCEEDED !!! CALL_OUT STOPPED !!!\n");
      StopCallOut(1);
      return;
    }
    if (num>CALL_OUT_SOFT)
    {
      filter_array(users(),#'tell_object,sprintf("WARNING! NUM OF CALL_OUTS exceeded (%d)! WILL STOP AT %d!\n",CALL_OUT_SOFT,CALL_OUT_HARD));
      write(sprintf("WARNING! NUM OF CALL_OUTS exceeded (%d)! WILL STOP AT %d!\n",CALL_OUT_SOFT,CALL_OUT_HARD));
    }
  }
  tmp=this_object();
  set_this_object(previous_object());
  efun::call_out(what,delay,arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9,
                 arg10,arg11,arg12,arg13,arg14,arg15);
  set_this_object(tmp);
  return;
}
#else
varargs void call_out(mixed what, int delay, mixed arg1, mixed arg2,
                      mixed arg3, mixed arg4, mixed arg5, mixed arg6,
                      mixed arg7, mixed arg8, mixed arg9, mixed arg10,
                      mixed arg11, mixed arg12, mixed arg13, mixed arg14,
                      mixed arg15)
{
  mixed tmp;
  mixed *call_outs;
  int i;
  
  call_outs=call_out_info();
  i=sizeof(call_outs)-1;
  if (i>600)
  {
    for(tmp=0;i>=0;i--)
    {
      if(call_outs[i][0]==previous_object() && call_outs[i][1]==what)
        tmp++;
    }
    if(tmp>=30 && geteuid(previous_object())!=ROOTID)
    {
      VOICEMASTER->SendToChannel("Debug",this_object(),SAY,sprintf("CALL_OUT overflow by object %O (%O)\n",previous_object(),what));
      /* with new channeld...
      VOICEMASTER->SendToChannel("Debug",previous_object(),sprintf("CALL_OUT overflow by object %O (%O)\n",previous_object(),what));
      */
      destruct(previous_object());
      return;
    }
  }
  tmp=this_object();
  set_this_object(previous_object());
  efun::call_out(what,delay,arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,arg9,
                 arg10,arg11,arg12,arg13,arg14,arg15);
  set_this_object(tmp);
  return;
}
#endif
#endif
#endif

// * Zu einer closure das Objekt, an das sie gebunden ist, suchen

mixed query_closure_object(closure c) {
  return
    CLOSURE_IS_UNBOUND_LAMBDA(get_type_info(c, 1)) ?
      0 :
  (to_object(c) || -1);
}

// * Wir wollen nur EIN Argument ... ausserdem checks fuer den Netztotenraum

varargs void move_object(mixed what, mixed where)
{
  object po,tmp;
  
  po=previous_object();
  if (!where)
  {
    where=what;
    what=po;
  }
  if (((stringp(where) && where==NETDEAD_ROOM ) || 
       (objectp(where) && where==find_object(NETDEAD_ROOM))) && 
       objectp(what) && file_name(what)!="/obj/sperrer")
  {
    if (!query_once_interactive(what))
    {
      what->remove();
      if (what) destruct(what);
      return;
    }
    if (living(what) || interactive(what))
    {
      log_file("NDEAD2",sprintf("TRYED TO MOVE TO NETDEAD: %O\n",what));
      return;
    }
    set_object_heart_beat(what,0);
  }
  tmp=what;
  while (tmp=environment(tmp))
    tmp->Set(P_LAST_CONTENT_CHANGE,time());
  (void)funcall(bind_lambda(#'efun::move_object,po),what,where);
  tmp=what;
  while (tmp=environment(tmp))
    tmp->Set(P_LAST_CONTENT_CHANGE,time());
}

// * additional message handling

private int living_or_interactive(object o)
{
  return (living(o) || query_once_interactive(o));
}

void shout(string s) {
  filter_array(users(), lambda(({'u}),({#'&&,
                                 ({#'environment, 'u}),
                                 ({#'!=, 'u, ({#'this_player})}), //'
                                   ({#'tell_object, 'u, to_string(s)})
                                   })));
}
                                
mapping living_name_m, name_living_m, netdead;

// * living_name-Behandlung

void start_simul_efun() {
  mixed *info;
 
  if ( !(info = get_extra_wizinfo(0)) )
    set_extra_wizinfo(0, info = allocate(BACKBONE_WIZINFO_SIZE));
  if (!(living_name_m = info[LIVING_NAME]))
    living_name_m = info[LIVING_NAME] = allocate_mapping(0, 1);
  if (!(name_living_m = info[NAME_LIVING]))
    name_living_m = info[NAME_LIVING] = allocate_mapping(0, 1);
  if (!(last_reboot = info[LAST_REBOOT]))
    last_reboot = info[LAST_REBOOT] = time();
  if (!(netdead = info[NETDEAD_MAP]))
    netdead = info[NETDEAD_MAP] = ([]);
  if (!(ip_map = info[IP_NAMES]))
    ip_map = info[IP_NAMES] = allocate_mapping(0,2);
  if (find_call_out("clean_simul_efun") < 0)
    efun::call_out("clean_simul_efun", 10);
}

void __clear_ip_map()
{
  mixed *info;

  info = get_extra_wizinfo(0);
  ip_map=info[IP_NAMES]=allocate_mapping(0,2);
}

// * regelmaessig Listen von Ballast befreien

#define clean_log(s)

//#define clean_log(s) log_file("CLEAN_SIM",ctime(time())[4..18]+": "+(s));

static void clean_name_living_m(string *keys, int left, int num) 
{
  int i, j;
  mixed a;
  
  while (left && num--) 
  {
    if (pointerp(a = name_living_m[keys[--left]]) && member(a, 0)>=0) 
    {
      a-=({0});
      name_living_m[keys[left]] = a;
    }
    if (!a || (pointerp(a) && !sizeof(a))) 
    {
      clean_log("Toasting "+keys[left]+"\n");
      efun::m_delete(name_living_m, keys[left]);
    } else clean_log(sprintf("KEEPING %s (%O)\n",keys[left],pointerp(a)?sizeof(a):a));
  }
  if (left)
    efun::call_out("clean_name_living_m", 1, keys, left, 80);
  else
    clean_log("Clean process finished\n");
}

static void clean_netdead()
{
  int i;
  string *s;
  object ob;
  
  s=m_indices(netdead);
  for (i=sizeof(s)-1;i>=0;i--)
    if (!objectp(ob=netdead[s[i]]) || interactive(ob))
      efun::m_delete(netdead,s[i]);
}

static void clean_simul_efun() {
  /* There might be destructed objects as keys. */
  m_indices(living_name_m);
  remove_call_out("clean_simul_efun");
  if (find_call_out("clean_name_living_m") < 0) {
    clean_log("Starting clean process\n");
    efun::call_out(
                   "clean_name_living_m",
                   1,
                   m_indices(name_living_m),
                   sizeof(name_living_m),
                   80
                   );
  }
  efun::call_out("clean_simul_efun", 7200);
  efun::call_out("clean_netdead",2);
}

void set_object_living_name(string name, object obj)
{
  string old;
  mixed a;
  int i;
 
  if (previous_object()==obj || previous_object()==this_object() ||
      file_name(previous_object())==__MASTER_OBJECT__)
  {
    if (old = living_name_m[obj]) {
      if (pointerp(a = name_living_m[old])) {
        a[member(a, obj)] = 0;
      } else {
        efun::m_delete(name_living_m, old);
      }
    }
    living_name_m[obj] = name;
    if (a = name_living_m[name]) {
      if (!pointerp(a)) {
        name_living_m[name] = ({a, obj});
        return;
      }
      /* Try to reallocate entry from destructed object */
      if ((i = member(a, 0)) >= 0) {
        a[i] = obj;
        return;
      }
      name_living_m[name] = a + ({obj});
      return;
    }
    name_living_m[name] = obj;
  }
}

void set_living_name(string name)
{
  set_object_living_name(name,previous_object());
}

void remove_living_name()
{
  string name;

  if (!previous_object())
    return;
  if (name=living_name_m[previous_object()])
  {
    efun::m_delete(living_name_m,previous_object());
    if (objectp(name_living_m[name]))
    {
      if (name_living_m[name]==previous_object())
        efun::m_delete(name_living_m,name);
      return;
    }
    if (pointerp(name_living_m[name]))
    {
      name_living_m[name]-=({previous_object()});
      if (!sizeof(name_living_m[name]))
        efun::m_delete(name_living_m,name);
    }
  }
}

void _set_netdead()
{
  if (query_once_interactive(previous_object()))
    netdead[getuid(previous_object())]=previous_object();
}

void _remove_netdead()
{
  efun::m_delete(netdead,getuid(previous_object()));
}

object find_netdead(string name)
{
  return netdead[name];
}

string *dump_netdead()
{
  return m_indices(netdead);
}

object find_living(string name) {
  mixed *a, r;
  int i;
  
  if (pointerp(r = name_living_m[name])) {
    if (member(r,0)>=0)
      r-=({0});
    if (!sizeof(r)){
      efun::m_delete(name_living_m,name);
      clean_log(sprintf("find_living loescht %s\n",name));
      return 0;
    }
    if ( !living(r = (a = r)[0])) {
      for (i = sizeof(a); --i;) {
        if (living(a[<i])) {
          r = a[<i];
          a[<i] = a[0];
          return a[0] = r;
        }
      }
    }
    return r;
  }
  return living(r) && r;
}

object *find_livings(string name)
{
  mixed r;

  if (pointerp(r=name_living_m[name]))
    r-=({0});
  else
    if (objectp(r))
      r=({r});
  if (!pointerp(r)||!sizeof(r))
    return 0;
  return r;
}

object find_player(string name) {
  mixed *a, r;
  int i;
  
  if (pointerp(r = name_living_m[name])) {
    if (member(r,0)>=0)
      r-=({0});  
    if (!sizeof(r)){
      efun::m_delete(name_living_m,name);
      clean_log(sprintf("find_player loescht %s\n",name));
      return 0;
    }
    if ( !(r = (a = r)[0]) || !query_once_interactive(r)) {
      for (i = sizeof(a); --i;) {
        if (a[<i] && query_once_interactive(a[<i])) {
          r = a[<i];
          a[<i] = a[0];
          return a[0] = r;
        }
      }
    }
    return r && query_once_interactive(r) && r;
  }
  return r && query_once_interactive(r) && r;
}

int check_match(string str)
{
  mixed *match;
  
  if (!(match=name_living_m[str]))
    return 0;
  if (!pointerp(match) || member(match,0)<0)
    return 1;
  if (sizeof(match))
    return 1;
  efun::m_delete(name_living_m,str);
  clean_log(sprintf("check_match loescht %s\n",str));
  return 0;
}

varargs mixed match_living(string str, int players_only)
{
  int i, s;
  mixed match,names,*a,r,*user;
  
  if (!str||str=="")
    return 0;
  if (check_match(str))
    return str;
  user=m_indices(name_living_m);
  s=strlen(str);
  match=0;
  for (i=sizeof(user)-1;i>=0;i--)
    if (str==user[i][0..s-1])
      if (match) 
        return -1;
      else
        if (check_match(user[i]))
          match=user[i];
  if (!match) 
    return -2;
  return match;
}

mixed *dump_livings()
{
  return sort_array(m_indices(name_living_m),#'>);
}

int send_imp(string host, int port, string message)
{
  return efun::send_imp(host,port,message);
}

#if __EFUN_DEFINED__(send_erq)
void cindent(string name)
{
    string valid;

    valid = funcall(
      bind_lambda(#'call_other, previous_object()),
      __MASTER_OBJECT__,
      "valid_write",
      name,
#if __EFUN_DEFINED__(geteuid)
      geteuid(previous_object()),
#else
      0,
#endif
      "cindent", previous_object()
    );
    if (valid)
      send_erq(ERQ_FORK, "indent_wrapper " + (stringp(valid) ? valid : name));
}
#else
void cindent(string name)
{
  raise_error("Sorry, no CINDENT today.");
}
#endif

#if !__EFUN_DEFINED__(query_comm_stat)
mixed *query_comm_stat()
{
  return ({0,0});
}
#endif

#if !__EFUN_DEFINED__(absolute_hb_count)
int absolute_hb_count()
{
  // return (last_reboot_time()-time())/2;
  return (time()-last_reboot_time())/2;
}
#endif

void __set_environment(object ob, mixed target)
{
  string path;
  object obj;

  if (!objectp(ob))
    return;
  if (!IS_ARCH(geteuid(previous_object())) || !IS_ARCH(this_interactive()))
    return;
  if (objectp(target))
  {
    efun::efun308(ob,target);
    return;
  }
  path=MASTER->_get_path(target,this_interactive());
  if (stringp(path) && file_size(path+".c")>=0 &&
      !catch(path->TU_GAR_NIX()))
  {
    obj=find_object(path);
    efun::efun308(ob,obj);
    return;
  }
}

void _dump_wizlist(string file, int sortby) {
  int i;
  mixed *a;

  if (!(IS_LORD(this_interactive()) || IS_LORD(previous_object())))
    return;
  if (!__MASTER_OBJECT__->valid_write(file,geteuid(previous_object()),"write_file"))
  {
    write("NO WRITE PERMISSION\n");
    return;
  }
  a = wizlist_info();
  a = sort_array(a, lambda( ({'a,'b}), 
                           ({#'<, 
                             ({#'[,'a,sortby}),
                             ({#'[,'b,sortby})
                            })));
  rm(file);
  for (i=sizeof(a)-1;i>=0;i--)
    write_file(file,sprintf("%-11s: eval=%-8d cmds=%-6d HBs=%-5d array=%-5d mapping=%-7d\n",a[i][WL_NAME],a[i][WL_EVAL_COST],a[i][WL_COMMANDS],a[i][WL_HEART_BEATS],a[i][WL_ARRAY_TOTAL],a[i][WL_CALL_OUT]));
}

varargs object deep_present(mixed what, object ob)
{
  object *inv;
  int cnt,i,size;
  string newwhat;
  
  if(!ob || !objectp(ob))
    ob=previous_object();
  if(objectp(what))
  {        
    for(i=sizeof(inv=deep_inventory(ob))-1;i>=0;i--)
      if(inv[i]==what)
        return what;
  }
  else
  {    
    if(stringp(what))
    {
      if(sscanf(what,"%s %d",newwhat,cnt)!=2)
        cnt=1;
      else
        what=newwhat;
      for(i=0,size=sizeof(inv=deep_inventory(ob));i<size;i++)
      {
        if(inv[i]->id(what))
          if(!--cnt)
            return inv[i];
      }
    }
  }
  return 0;
}

mapping dump_ip_mapping()
{
  return copy_mapping(ip_map); 
}

int binary_message(mixed *message, int flags)
{
  return 0;
}

varargs int query_mud_port(object pl)
{
//  if (!pl) pl=users()[0];
  return efun::query_mud_port();
}

nomask void swap(object obj)
{
  write("Your are not allowed to swap objects by hand!\n");
  return;
}

nomask void garbage_collection()
{
  write("Call GC now and the mud will crash in 5-6 hours. DONT DO IT!\n");
  return;
}

void notify_fail(string str)
{
  if (!TP) return;
  TP->SetProp(P_ACTUAL_NOTIFY_FAIL,previous_object());
  return efun::notify_fail(str);
}

void _notify_fail(string str)
{
  object o;

  if (!TP) return;
  if ((o=TP->QueryProp(P_ACTUAL_NOTIFY_FAIL)) && o!=previous_object()) 
    return;
  TP->SetProp(P_ACTUAL_NOTIFY_FAIL,previous_object());
  return efun::notify_fail(str);
}

object shadow(object ob, int flag)
{
  set_this_object(previous_object());
  return efun::shadow(ob, flag);
}


string time2string( string format, int time )
{
  int days,hours,mins,secs,i,ch,max,abbr,dummy;
  string *parts, fmt;

  secs = time;
  mins = (time/60);
  hours = (time/3600);
  days = (time/86400);
  abbr = 0;

  parts = regexplode( format, "\(%\(-|\)[0-9]*[dhmsxDHMSX]\)|\(%%\)" );

  max = 0;
  for( i=1; i<sizeof(parts); i+=2 )
  {
    ch = parts[i][<1];
    switch( parts[i][<1] )
    {
    case 'x': case 'X':
        abbr = sscanf( parts[i], "%%%d", dummy ) && dummy==0;
        // NO break !
    case 'd': case 'D':
        max |= 7;
        break;
    case 'h': case 'H':
        max |= 3;
        break;
    case 'm': case 'M':
        max |= 1;
        break;
    }
  }
  if( max & 4 ) hours %= 24;
  if( max & 2 ) mins %= 60;
  if( max ) secs %= 60;

  for( i=1; i<sizeof(parts); i+=2 )
  {
    fmt = parts[i][0..<2];
    ch = parts[i][<1];
    if( ch=='x' )
    {
      if( days>0 ) ch='d';
      else if( hours>0 ) ch='h'; else ch = (mins>0) ? 'm' : 's';
    } else if( ch=='X' )
    {
      if( days>0 ) ch='D';
      else if( hours>0 ) ch='H'; else ch = (mins>0) ? 'M' : 'S';
    }
    switch( ch )
    {
      case 'd': parts[i] = sprintf( fmt+"d", days ); break;
      case 'h': parts[i] = sprintf( fmt+"d", hours ); break;
      case 'm': parts[i] = sprintf( fmt+"d", mins ); break;
      case 's': parts[i] = sprintf( fmt+"d", secs ); break;
      case 'D':
        if(abbr) parts[i] = "d"; else
        parts[i] = sprintf( fmt+"s", (days==1) ? "Tag" : "Tage" );
        break;
      case 'H':
        if(abbr) parts[i] = "h"; else
        parts[i] = sprintf( fmt+"s", (hours==1) ? "Stunde" : "Stunden" );
        break;
      case 'M':
        if(abbr) parts[i] = "m"; else
        parts[i] = sprintf( fmt+"s", (mins==1) ? "Minute" : "Minuten" );
        break;
      case 'S':
        if(abbr) parts[i] = "s"; else
        parts[i] = sprintf( fmt+"s", (secs==1) ? "Sekunde" : "Sekunden" );
        break;
      case '%':
        parts[i] = "%";
        break;
      }
    }
    return implode( parts, "" );
}

#if !__EFUN_DEFINED__(query_ip_port)
nomask varargs int query_ip_port(object pl)
{
  return 4711;
}
#endif

nomask mixed debug_info(int flag, object ob)
{
  if ((flag == 2) && this_player() && !IS_ARCH(this_player())) return;
  if (flag == 6) return efun::debug_info(flag);
  return efun::debug_info(flag,ob);
}

#if !__EFUN_DEFINED__(count_bits)
int count_bits(string s)
{
  int i,j,k;

  if (!stringp(s) || !(j=strlen(s)))
    return 0;

  for (--j, k=0; j>=0; j--)
    for (i=5; i>=0; i--)
      if (test_bit(s,6*j+i))
        k++;

  return k;
}
#endif
