/* SilberLand MUDlib
 *
 * /secure/udp/www.who.c -- WWW who
 *
 * $Date: 1997/07/01 16:45:08 $
 * $Revision: 1.4 $
 * $Log: www.who.c,v $
 * Revision 1.4  1997/07/01 16:45:08  Woody
 * Farbwert fuer Seher nochmal korrigiert...
 *
 * Revision 1.3  1997/07/01 16:12:39  Woody
 * Bugfix *argl* hatte break vergessen...
 *
 * Revision 1.2  1997/07/01 16:07:15  Woody
 * ueberarbeitet, Tabellenform
 *
 * Revision 1.1  1997/03/16 00:51:55  Woody
 * prepared for revision control
 *
 */

// MorgenGrauen MUDlib Contribution

#pragma strong_types
#pragma combine_strings

#include <properties.h>
#include <www.h>

#define COL_TEXT	"black"
#define COLBG_SPIELER	"lightgray"
#define COLBG_SEER	"gray"

string MakeLink(mixed entry)
{
  string nm;
  string col;
  nm = (string)getuid(entry[0]);
  switch(query_wiz_level(entry[0])) {
    case 0: col="white"; break;
    case 1: col="#f0f0d8"; break;
    case 2..59: col="#f0d0b0"; break;
    default: col="#f0b0b0";
  }
  /*
  return "<TR BGCOLOR="+col+">"
    "<TD ALIGN=CENTER>"+entry[1]+"</TD>"
    "<TD>"+entry[2]
       + "<A HREF=\""+MUDWWW+"?"+REQ+"="+R_FINGER+"&"+USER+"="+nm+"\"><B>"
       + capitalize(nm)
       + "</B></A>"
       +entry[3]
    + "</TD><TD ALIGN=CENTER>"
    + entry[4]+", "+entry[5]
    + "</TD><TD ALIGN=RIGHT>"
    + entry[6]
    + "</TD></TR>";
  */
  return 
    "<TR>"+
    "<TD ALIGN=CENTER>"+entry[1]+"</TD>"
    "<TD>"+entry[2]+"<A HREF=\""+MUDWWW+"?"+REQ+"="+R_FINGER+"&"+USER+"="+nm+"\">"+capitalize(nm)+"</B></A>"+entry[3]+"</TD>"+
    "<TD>"+entry[4]+", "+entry[5]+"</TD>"+
    "<TD>"+entry[6]+"</TD>"+
    "</TR>";    
}

string Request(mapping cmds)
{
  string *who;
  if (!sizeof(cmds)) return ERROR("Anfrage ung&uuml;ltig!");
  who = map_array(WHO, #'MakeLink);
  return "<TABLE BORDER=1 WIDTH=100%>"
//       + "<TR BGCOLOR=#b0f0f0>"
       + "<TR>"
       + "<TH>Status</TH>"
       + "<TH ALIGN=LEFT>Voller Name</TH>"
       + "<TH>Rasse, Gesinnung</TH>"
       + "<TH ALIGN=RIGHT>eingeloggt von</TH>"
       + "</TR>\n"
       + implode(who, "\n")+"</TABLE>";
}
