// Tamedhon MUDLIB
//
// std/npc/items.c -- AddItem() fuer NPCs
//
// $Date: 2000/06/04 18:59:08 $
/* $Revision: 1.1 $
 * $Log: items.c,v $
 * Revision 1.1  2000/06/04 18:59:08  Samtpfote
 * Initial revision
 *
 */
#pragma strict
#pragma strong-types

#include <moving.h>
#include <npc/items.h>

#define ADB(x)		if(find_player("samtpfote")) \
			    tell_object(find_player("samtpfote"), \
			    break_string(x, 79, "{ npc/items.c } "));


void AddItem(mixed what, int clone_method)
{
    object	ob;
	string	file;
	
	if(stringp(what)) 
	{
	  file=what;
	}
	else if(pointerp(what))		/* array? */
	{
	  file=what[random(sizeof(what))];
	}
	
    //ADB(file);	

    catch(ob=clone_object(file));
    if(!ob)
    {
	raise_error(sprintf("%O: could not access file %s for cloning!\n",
			this_object(), file));
	return;			
    }
    
    switch(clone_method)
    {
	case CLONE_WIELD:
	    ob->move(this_object(), M_GET|M_SILENT);
	    ob->wield_me(1);
	    break;
	    
	case CLONE_WEAR:
	    ob->move(this_object(), M_GET|M_SILENT);
	    ob->DoWear(1);
	    break;
    
	case CLONE_MOVE:
	default:
	    ob->move(this_object(), M_GET|M_SILENT);
	    break;
    }
}
