// SilberLand MUDlib
//
// std/store.c -- base storage room
//
// $Date: 1997/03/13 03:14:42 $
/* $Revision: 3.0 $
 * $Log: store.c,v $
 * Revision 3.0  1997/03/13 03:14:42  Woody
 * prepared for revision control
 *
 * Revision 2.9  1995/07/11  16:56:30  Jof
 * *** empty log message ***
 *
 * Revision 2.8  1995/07/11  16:54:49  Jof
 * *** empty log message ***
 *
 * Revision 2.7  1995/07/11  14:27:26  Jof
 * Ask bank for values now (runtime changeable!)
 *
 * Revision 2.6  1995/07/10  17:26:06  Jof
 * Only call bank if sum!=0 to keep logs clean
 *
 * Revision 2.5  1995/07/10  07:32:17  Jof
 * use bank.h
 *
 * Revision 2.4  1995/02/06  19:44:14  Jof
 * RCS-Logs aufgeraeumt (leere Logs raus usw)
 *
*/


#define ANZ 3
#include <properties.h>
#include <bank.h>

inherit "/std/thing/properties";
inherit "/std/room/items";

mixed *all,all2;
object shop;
int sum;
int store_percent_left;

_set_store_percent_left()
{
  store_percent_left=ZENTRALBANK->_query_store_percent_left();
}

_register_shop(ob)
{
  shop=ob;
}

create()
{
  seteuid(getuid());
  properties::create();
  items::create();
  _set_store_percent_left();
}

void clean_double() {}

void reset()
{
  items::reset();
  _set_store_percent_left();
  all=all_inventory(this_object());
  if (sizeof(all)==0)
  {
    all=0;
    return;
  }
  all2=order_alist(({({}),({})}));
  call_out("aufraeumen",random(10));
  if (sum)
    if (!shop)
      ZENTRALBANK->PayIn(sum);
    else
      shop->_add_money(sum);
  sum=0;
} 

aufraeumen()
{
  int i;
  int size;
  mixed element,got;

  i=30;
  size=sizeof(all);
  if (i>=size) 
    i=size-1;
  while (i>0)
  {
    element=explode(file_name(all[size-1-i]),"/")[0];
    if (element=="players"||element=="d")
      element=explode(file_name(all[size-1-i]),"#")[0];
    else
      element=all[size-1-i]->short()+explode(file_name(all[size-1-i]),"#")[0];
    got=assoc(element,all2);
    if (pointerp(got))
    {
      if (got[1]<ANZ-1) 
      {
	got[1]++;
	all2=insert_alist(element,got,all2);
      } else 
      {
	sum+=all[size-1-i]->QueryProp(P_VALUE)*store_percent_left/100;
	catch(all[size-1-i]->remove());
	if (all[size-1-i])
	  destruct(all[size-1-i]);
      }
    } else all2=insert_alist(element,({all[size-1-i],1}),all2);
    i--;
  }
  if (size<31)
    all=({});
  else
    all=all[0..size-31];
  if (!sizeof(all))
  {
    all=0;
    all2=0;
  } 
  else
    call_out("aufraeumen",0);
} 

int clean_up(int refcount) { return 1; }

int _query_current_money()
{
  return sum;
}
