// Amethyst 

inherit "std/unit";

#include <properties.h>
#include <language.h>

create()
{
  if (!is_clone(this_object()) )  return;

  ::create();

  SetProp(P_SHORT, "Ein Amethyst");
  SetProp(P_LONG,  
    "Ein kleiner, blauer Amethyst.");
  SetProp(P_INFO, 
    "Der Amethyst ist relativ haeufig und daher nicht so viel wert wie andere "
    "Edelsteine.\n");
  SetProp(P_NAME, ({"Amethyst", "Amethyste"}) );
  SetProp(P_GENDER, MALE);

  AddSingularId( ({"amethyst", "edelstein"}) );
  AddPluralId( ({"amethyste", "edelsteine"}) );
  AddId( "EDELSTEIN" );
  SetCoinsPerUnits(50,1);
  SetGramsPerUnits(5,1);

  SetProp(P_MATERIAL, MAT_AMETHYST );
  SetProp(P_NOBUY, 1);

}
