// Bergkristall 

inherit "std/unit";

#include <properties.h>
#include <language.h>

create()
{
  if (!is_clone(this_object()) )  return;

  ::create();

  SetProp(P_SHORT, "Ein Bergkristall");
  SetProp(P_LONG,  
    "Ein wunderbar funkelnder Bergkristall. Er reflektiert das Licht und "
    "und scheint dadurch in den verschiedensten Farben zu glaenzen. Du "
    "kannst kaum den Blick von solcher Schoenheit wenden. Er ist etwa 20 cm "
    "lang und 5 cm breit. Seine fuenf Kanten laufen vorne zu einem "
    "gleichmaessigen Spitz zusammen." );
  SetProp(P_INFO, 
    "Der Bergkristall wird oft fuer heilige Rituale verwendet.\n");
  SetProp(P_NAME, ({"Bergkristall", "Bergkristalle"}) );
  SetProp(P_GENDER, MALE);

  AddSingularId( ({"bergkristall", "kristall", "edelstein"}) );
  AddPluralId( ({"bergkristalle", "kristalle", "edelsteine"}) );
  AddId( "EDELSTEIN" );
  SetCoinsPerUnits(90,1);
  SetGramsPerUnits(5,1);

  SetProp(P_MATERIAL, MAT_QUARTZ );
  SetProp(P_NOBUY, 1);

}
