// Diamant  

inherit "std/unit";

#include <properties.h>
#include <language.h>

create()
{
  if (!is_clone(this_object()) )  return;

  ::create();

  SetProp(P_SHORT, "Ein Diamant");
  SetProp(P_LONG,  
    "Diamanten gelten nicht umsonst als die wertvollsten und schoensten "
    "Edelsteine. Der Diamant funkelt und glitzert im Licht, als ob er "
    "selber eine Lichtquelle waere. Ausserdem gibt es kaum ein Material, "
    "das haerter ist, als ein Diamant.");
  SetProp(P_INFO, break_string( 
    "Wenn ein Lichtstrahl auf einen Diamanten trifft, kann man schon fast "
    "von einer Lichtexpolsion sprechen. Und tatsaechlich haben viele "
    "Diamanten eine starke Beziehung zu explosiven Kraeften.",78) );
  SetProp(P_NAME, ({"Diamant", "Diamanten"}) );
  SetProp(P_GENDER, MALE);

  AddSingularId( ({"diamant", "edelstein"}) );
  AddPluralId( ({"diamanten", "edelsteine"}) );
  AddId( "EDELSTEIN" );
  SetCoinsPerUnits(800,1);
  SetGramsPerUnits(5,1);

  SetProp(P_MATERIAL, MAT_DIAMOND );
  SetProp(P_NOBUY, 1);

}
