//  Topas

inherit "std/unit";

#include <properties.h>
#include <language.h>

create()
{
  if (!is_clone(this_object()) )  return;

  ::create();

  SetProp(P_SHORT, "Ein Topas");
  SetProp(P_LONG,  
    "Der Topas ist ein sonnengelber Edelstein.");
  SetProp(P_INFO, 
    "Topase haben eine luftige Ausstrahlung.\n");
  SetProp(P_NAME, ({"Topas", "Topase"}) );
  SetProp(P_GENDER, MALE);

  AddSingularId( ({"topas", "edelstein"}) );
  AddPluralId( ({"topase", "edelsteine"}) );
  AddId( "EDELSTEIN" );
  SetCoinsPerUnits(180,1);
  SetGramsPerUnits(5,1);

  SetProp(P_MATERIAL, MAT_TOPAZ );
  SetProp(P_NOBUY, 1);

}
