//  Zirkon

inherit "std/unit";

#include <properties.h>
#include <language.h>

create()
{
  if (!is_clone(this_object()) )  return;

  ::create();

  SetProp(P_SHORT, "Ein Zirkon");
  SetProp(P_LONG,  
    "Der Zirkon ist ein Edelstein von brauner Farbe.");
  SetProp(P_INFO, break_string(
    "Zirkone sollen angeblich sogar elektrischen Strom leiten koennen, "
    "aber was ist Strom ueberhaupt?.", 78));
  SetProp(P_NAME, ({"Zirkon", "Zirkone"}) );
  SetProp(P_GENDER, MALE);

  AddSingularId( ({"zirkon", "edelstein"}) );
  AddPluralId( ({"zirkone", "edelsteine"}) );
  AddId( "EDELSTEIN" );
  SetCoinsPerUnits(350,1);
  SetGramsPerUnits(5,1);

  SetProp(P_MATERIAL, MAT_MISC_JEWEL );
  SetProp(P_NOBUY, 1);

}
