/* Neuer Standardelf
 * Samtpfote@tamedhon
 *
 *
 */

#include <class.h> 
#include <properties.h>
#include <combat.h>
#include <moving.h>

#ifdef LOG
#undef LOG
#endif
#define LOG(x, text) write_file("/log/statistik/npcs/"+x, text)


inherit "/std/mnpc";
inherit "/std/player/moneyhandler";

string *_query_racestring()
{
    if(QueryProp(P_GENDER) == MALE)
    {
	return ({"Elf", "Elfens", "Elf", "Elf"});
    }
    else
    {
	return ({"Elfin", "Elfins", "Elfin", "Elfin"});
    }
}

void create_default_elf(int level)
{
    int	num;

    ::create_default_npc(level);
    SetProp(P_SPELLRATE, 10+level/2+random(level*2)); 
    if(QueryProp(P_SPELLRATE) >= 100)
    { SetProp(P_SPELLRATE, 80+random(16)); }

    if(level <= 35+random(6))
    { 
	SetProp(P_ATTRIBUTES, 
	    ([A_CON: level+(random(level)/6)-(random(level)/6),
	      A_DEX: level+(random(level)/6)-(random(level)/6),
	      A_INT: level+(random(level)/6)-(random(level)/6),
	      A_STR: level+(random(level)/6)-(random(level)/6)
	    ]));
    }
    else
    {
	SetProp(P_ATTRIBUTES, ([A_CON: 35, A_DEX: 35, A_INT: 35, A_STR: 35]));
    }
    
    SetProp(P_BODY, (level<30?level*2:level)+random(15));
    SetProp(P_HANDS, 
	({" mit blanken Faeusten",
	  40+(level/3)*10+random(10),
	  DT_BLUDGEON
	}));
        
    AddId("\nelf");
    AddId("elf");
    
    SetProp(P_GENDER, MALE);
    SetProp(P_NAME, "Elf");
    SetProp(P_RACE, "Elf");
    SetProp(P_SHORT, "Ein unbeschriebener Elf");
    SetProp(P_LONG, "Das ist ein unbeschriebener Elf.\n");
    SetProp(P_AVERAGE_SIZE, 190);
    SetProp(P_SIZE, random(40)+170);
    SetProp(P_AVERAGE_WEIGHT, 60000);
    SetProp(P_WEIGHT, random(84000)+56000);
    SetProp(P_ATTRIBUTES_OFFSETS, 
	([A_DEX: 3, A_CON: 1, A_INT: 4, A_STR: -2]));
    SetProp(P_MAX_HANDS, 2);
    /*
    SetProp(P_AGGRESSIVE, 
	([P_RACE: (["Ork":	0.1,
		    "Goblin":	0.8,
		    "Troll":	0.8,
		    "Oger":	0.8,
		    "Dunkelelf":0.1,
		  ]),
	]));
    */
    SetProp(P_DEFAULT_INFO,
	({"zuckt ahnungslos mit den Schultern.\n",
	  "laechelt weise.\n",
	  "schmunzelt geheimnisvoll.\n",
	  "flauscht Dich sanft und troestet Dich.\n",
	  "bedauert, das noch nicht in Erfahrung gebracht zu haben.\n",
	  "hat davon keinen Schimmer.\n",
	  "interessiert sich nicht dafuer.\n",
	  "gruebelt darueber nach, aber hat trotzdem keine Ahnung.\n"
	}));
    SetProp(P_LOG_INFO, 1);
    SetProp(P_RESISTANCE, ({DT_HOLY, DT_LIGHT, DT_MAGIC}));
    SetProp(P_VULNERABILITY, ({DT_UNHOLY, DT_TERROR}));
    SetProp(P_TEMPERATURE_RANGE, ([T_RANGE_MIN: 10, T_RANGE_MAX: 30]));  
    SetProp(P_NOMAGIC, 10);
    SetProp(P_SPELLRATE, 35);
    SetProp(P_WIMPY, 0);
    SetProp(P_KILL_MSG, "Wage es nie wieder, das Gute anzugreifen!!");
    SetProp(P_DIE_MSG, " betet zur Goettin und befiehlt sich in ihre Arme.\n");

    SetProp(P_MSGIN, "wandelt leichten Fusses herein");
    SetProp(P_MSGOUT, "wandelt leichten Fusses#");
    SetProp(P_MMSGIN, "verdichtet sich aus einer magischen Wolke");
    SetProp(P_MMSGOUT, "loest sich in einer duftenden Wolke auf");

    
    SetProp(P_MAX_FOOD, 100);
    SetProp(P_MAX_ALCOHOL, 70);
    SetProp(P_MAX_DRINK, 130);
    
    SetProp(P_ALIGN, 100+random(300));
    
    AddClass(CL_HUMANOID);
    AddClass(CL_ELF);        
}

void create_default_npc(int level)
{ create_default_elf(level); }


int create()
{
    if(!is_clone(this_object())) return 0;
    ::create();
}
